import sys
# lspstats and lsprofile
# were written by Brett Rosen and Ted Czotter.

def mySort(b, a, crit):
    if a[crit] > b[crit]:
        return 1
    elif a[crit] < b[crit]:
        return -1
    else:
        return 0

criteria = [ "Label", "CallCount", "RecursiveCallCount", "TotalTime", "InlineTime" ]
def sort(data, crit=None):
    if crit is None:
        s = "CallCount"
    elif crit in criteria:
        s = crit
    else:
        raise ValueError, "Can't sort by %s" % crit
    data = list(data)
    data.sort(lambda a, b: mySort(a,b, s))

    for e in data:
        if "Calls" in e:
            e['Calls'] = list(e['Calls'])
            e['Calls'].sort(lambda a, b: mySort(a,b, s))
        else:
            e['Calls'] = list()
    return data


def display(data, crit=None, top=None, printer=None):
    if printer is None:
        printer = sys.stdout
    d = sort(data, crit)
    if top is None:
        top = len(d)
    top = min(top, len(d))
    cols = "% 12s %12s %11.4f %11.4f %50s\n"
    hcols = "% 12s %12s %12s %12s %s\n"
    cols2 = "+%12s %12s %11.4f %11.4f +%50s\n"
    printer.write(hcols % ("CallCount", "Recursive", "Total(ms)", "Inline(ms)", "Label"))
    i = 1
    for e in d:
        if i > top:
            break
        i += 1
        printer.write(cols % (e['CallCount'], e['RecursiveCallCount'], e['TotalTime'], e['InlineTime'] ,e["Label"]))
        for se in e['Calls']:
            printer.write(cols % ("+%s" % se['CallCount'], se['RecursiveCallCount'], se['TotalTime'], se['InlineTime'] , "+%s" % se["Label"]))

            